package emulascript;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.LinkedList;

public class Gossip5Generator {
	public static final String DIR = "/home/donatello/celebrities5/";
	
	public static final String[] gUsers = {"5490392", "11522502", "14164855", "18915240", "11738562"};
	public static final int[] gInterval = {45, 45, 43, 25, 13};
	public static final int[] gStart = {15, 30, 45, 7, 27};
	
	public void generateTimeTable(String uId, int interval, int start) {
		try {
			LinkedList<String> tweets = new LinkedList<String>();
			
			BufferedReader is = new BufferedReader(new FileReader(DIR+uId));
			String line = null;
			while((line = is.readLine()) != null) {
				line = line.trim();
				
				String[] split = line.split(" ");
				Integer mark = Integer.valueOf(split[0]);
				
				if(mark == 2) {
					String tweet = "";
					for(int i=3; i<split.length; i++) {
						tweet += split[i];
						tweet += " ";
					}
					tweets.addLast(tweet);
				}				
			}
			is.close();
			
			//print
			//Iterator<String> iterator = tweets.iterator();
			//while(iterator.hasNext()) {
			//	System.out.println(iterator.next());
			//}
			
			//generate
			PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(DIR+uId+"_event")));
			os.println("0 5000");
			
			String firstTweet = tweets.removeFirst();
			os.println("3 " + start*60000 + " " + firstTweet);
			
			Iterator<String> iterator = tweets.iterator();
			while(iterator.hasNext()) {
				long tune = 1;
				if(Math.random() * 10 > 0.5) { tune = -1; }
				//long tune = (long) (Math.pow(-1.0, Math.random()*100.0));// * Math.random() * 5.0 * 60000.0);
				System.out.println(tune);
				long waitperiod = interval*60000 + (long) (tune * Math.random() * 5.0 * 60000.0);
				os.println("3 " + waitperiod + " " + iterator.next());
			}
			os.println("1 " + interval*60000);
			os.flush();
			os.close();
			
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		Gossip5Generator g5g = new Gossip5Generator();
		for(int i=0; i<gUsers.length; i++) {
			g5g.generateTimeTable(gUsers[i], gInterval[i], gStart[i]);
		}
	}
}
