package emulascript;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.LinkedList;

import rice.environment.Environment;
import application.Cuckoo;

public class ThreadEmulator {
	public static final String ALLFILES = "./xml/";
	public static final String LOCAL_IP_ADDRESS = "./localIpAddress";
	
	private LinkedList<Cuckoo> mycuckoos = new LinkedList<Cuckoo>();
	
	private Environment env;
	//private InetSocketAddress bootaddress;
	private InetAddress bootaddr;
	//private int bootport;
	
	public static String USERNPORT;// = "./userNport";
	
	public ThreadEmulator(String usernport) {
		USERNPORT = usernport;
		
		// Loads pastry settings
		env = new Environment();
		env.getParameters().setString("nat_search_policy", "never");
		
		try {
			String localIp = getIpAddress(LOCAL_IP_ADDRESS);
			
			//InetAddress bootaddr = InetAddress.getLocalHost();
			bootaddr = InetAddress.getByName(localIp);
			//bootport = BootstrapGuardian.GUARDIAN_PORT;
			//bootaddress = new InetSocketAddress(bootaddr, bootport);
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
		initCuckoos(env);
		//setBootstrappingNodes(env);
	}
	
	/*
	public void setBootstrappingNodes(Environment env) {
		Cuckoo c = new Cuckoo(env, "1", bootaddress, 9000);
		c.bootstrap();
	}
	*/
	
	public void initCuckoos(Environment env) {
		try {
			BufferedReader is = new BufferedReader(new FileReader(USERNPORT));
			String cfgline;
			while((cfgline = is.readLine()) != null) {
				cfgline = cfgline.trim();
				if(cfgline.compareTo("") != 0) {
					String[] split  = cfgline.split("#");
					String userid   = split[0];
					InetAddress bindaddr = bootaddr;
					int bindport    = Integer.valueOf(split[1]).intValue();
					//first clean the last run effect
					doCleaningJob(userid);
					//then initialization
					initCuckoo(userid, bindaddr, bindport, env);
				}
			}
			is.close();
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
	}
	
	private void initCuckoo(String userid, InetAddress bindaddr, int bindport, Environment env) {
		int index = (int) (Math.random() * BootstrapGuardian.NUM_OF_GUARDIAN);
		int bootport = BootstrapGuardian.GUARDIAN_PORT + index;
		InetSocketAddress bootaddress = new InetSocketAddress(bootaddr, bootport);
		Cuckoo cuckoo = new Cuckoo(env, userid, bootaddress, bindaddr, bindport);
		mycuckoos.addLast(cuckoo);
	}
	
	//Use different threads to publish contents
	public void comeOnBaby() {
		for(int i=0; i<mycuckoos.size(); i++) {
			new Thread(mycuckoos.get(i)).start();
		}
		mycuckoos.clear();
	}
	
	/*
	public void die(Cuckoo cuckoo) {
		mycuckoos.remove(cuckoo);
	}
	*/
	
	public void doCleaningJob(String userid) {
		//TODO
		String dir = ALLFILES + userid + "/";
		String[] delfiles = {dir+"mystatus.xml", dir+"followeestatus.xml", dir+"trafficanalysis.dat", dir+"gossipanalysis.xml"};
		for(int i=0; i<delfiles.length; i++) {
			File delfile = new File(delfiles[i]);
			delfile.delete();
		}
	}
	
	public static String getIpAddress(String ipfile) {
		String ip = null;
		try {
			BufferedReader is = new BufferedReader(new FileReader(ipfile));
			ip = is.readLine().trim();
		} catch(IOException ioe) {
			ioe.printStackTrace();
		}
		return ip;
	}
	
	public static void main(String[] args) {
		//BootstrapGuardian guard = new BootstrapGuardian();
		//guard.launchBootstrappingNodes();
		//System.out.println("-------guard launched--------");
		ThreadEmulator te = new ThreadEmulator(args[0]);
		te.comeOnBaby();
	}
}
