package emulascript;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.LinkedList;

import application.Cuckoo;
import application.Profile;
import database.PartnerXMLDB;
import database.ProfileXMLDB;

public class ThreadUserDataGenerator {
	public static final String IDLIST = "/home/donatello/TwData_30thsd/IdListAll";
	public static final String USERNPORT_DIR = "/home/donatello/TwData_30thsd/UserNPort/";
	
	//public static final String ALLDIR = "D:/TwTest/"; //raw data
	//public static final String USERDATA = "D:/UserData/"; //user's xml-based data
	//public static final String USERNPORT = "./userNport";
	//public static final String EMU_DATA = "D:/EmulationData/"; //emulation data
	
	public static final String EVENT_DIR = "/home/donatello/TwData_30thsd/event/";
	public static final String FOLLOWEE_DIR = "/home/donatello/TwData_30thsd/followee/";
	public static final String FOLLOWER_DIR = "/home/donatello/TwData_30thsd/follower/";
	
	public static final String THREAD_EMULATION_DATA = "/home/donatello/TwData_30thsd/CuckooData/";
	
	//make dirs for each user
	public void mkdirs() {
		try {
			//first make the outter dir
			File outdir = new File(THREAD_EMULATION_DATA);
			if(outdir.exists() == false) {
				outdir.mkdir();
			}
			
			BufferedReader is = new BufferedReader(new FileReader(IDLIST));
			String userId = null;
			while((userId = is.readLine()) != null) {
				userId = userId.trim();
				File idfile = new File(THREAD_EMULATION_DATA+userId);
				idfile.mkdir();
			}
			is.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public void buildPortFile() {
		File portDir = new File(USERNPORT_DIR);
		File[] portfiles = portDir.listFiles();
		
		for(int i=0; i<portfiles.length; i++) {
			try {
				int t = i+1;
				BufferedReader is = new BufferedReader(new FileReader(USERNPORT_DIR+"userNport"+t));
				String line = null;
				while((line = is.readLine()) != null) {
					line = line.trim();
					String[] split = line.split("#");
					String userId = split[0];
					PrintWriter os = new PrintWriter(new BufferedWriter(new FileWriter(THREAD_EMULATION_DATA+userId+"/"+userId+"_port")));
					os.println(line);
					os.flush();
					os.close();
				}
				is.close();
			} catch(IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	//Here we do not care the username, web, location & bio
	public void buildXMLProfiles() {
		try {
			BufferedReader is = new BufferedReader(new FileReader(IDLIST));
			String userId = null;
			while((userId = is.readLine()) != null) {
				userId = userId.trim();
				String dir = THREAD_EMULATION_DATA+userId;
				ProfileXMLDB myProfileDB = new ProfileXMLDB(dir, dir + "/myproINIT_BLOODfile.xml", "myprofile");
				myProfileDB.addProfile(new Profile(userId, "n", "n", "n", "n"), null);
			}
			is.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	//Here we build the followee/follower xml-based db.
	//Still, we just care the userId
	public void buildFolloweeLinks() {
		try {
			BufferedReader is = new BufferedReader(new FileReader(IDLIST));
			String userId = null;
			while((userId = is.readLine()) != null) {
				String dir = THREAD_EMULATION_DATA+userId;
				
				//if exist, delete
				File file = new File(dir + "/followeeprofile.xml");
				if(file.exists()) {file.delete();}
				
				ProfileXMLDB followeeProfileDB = new ProfileXMLDB(dir, dir + "/followeeprofile.xml", "followeeprofile");
				try {
					BufferedReader fis = new BufferedReader(new FileReader(FOLLOWEE_DIR+userId.substring(0,1)+"/"+userId+"_followee"));
					String followeeId;
					while((followeeId = fis.readLine()) != null) {
						followeeId = followeeId.trim();
						String followeefollower = FOLLOWER_DIR+followeeId.substring(0,1)+"/"+followeeId+"_follower";
						followeeProfileDB.addProfile(new Profile(followeeId, "n", "n", "n", "n"), followeefollower);
					}
					fis.close();
				} catch(IOException ioe) {
					ioe.printStackTrace();
				}
			}
			is.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public void buildFollowerLinks() {
		try {
			BufferedReader is = new BufferedReader(new FileReader(IDLIST));
			String userId = null;
			while((userId = is.readLine()) != null) {
				String dir = THREAD_EMULATION_DATA+userId;
				
				//if exist, delete
				File file = new File(dir + "/followerprofile.xml");
				if(file.exists()) {file.delete();}
				
				ProfileXMLDB followerProfileDB = new ProfileXMLDB(dir, dir + "/followerprofile.xml", "followerprofile");
				try {
					String followerpath = FOLLOWER_DIR+userId.substring(0,1)+"/"+userId+"_follower";
					File f = new File(followerpath);
					if(f.exists() == false) {
						f.createNewFile();
					}
					BufferedReader fis = new BufferedReader(new FileReader(f));
					String followerId;
					while((followerId = fis.readLine()) != null) {
						followerId = followerId.trim();
						followerProfileDB.addProfile(new Profile(followerId, "n", "n", "n", "n"), null);
					}
					fis.close();
				} catch(IOException ioe) {
					ioe.printStackTrace();
				}
			}
			is.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public void buildPartners() {
		try {
			BufferedReader is = new BufferedReader(new FileReader(IDLIST));
			String userId = null;
			while((userId = is.readLine()) != null) {
				String dir = THREAD_EMULATION_DATA+userId;
				
				//if exist, delete
				File file = new File(dir + "/partner.xml");
				if(file.exists()) {file.delete();}
				
				PartnerXMLDB partnerXMLDB = new PartnerXMLDB(dir, dir + "/partner.xml", "partner");
				ProfileXMLDB followeeProfileDB = new ProfileXMLDB(dir, dir + "/followeeprofile.xml", "followeeprofile");
				LinkedList<String> followees = followeeProfileDB.getAllUserIds();
				Iterator<String> iterator = followees.iterator();
				while(iterator.hasNext()) {
					String fid = iterator.next();
					String followeesfollowers = FOLLOWER_DIR + fid.substring(0,1) + "/" + fid + "_follower";
					//TODO
					int partnerNum = ((int) Math.ceil(Math.log(ProfileXMLDB.getNumOfLine(followeesfollowers)))) + Cuckoo.C;
					String[] partners = ProfileXMLDB.buildPartners(followeesfollowers, fid, partnerNum);
					partnerXMLDB.initWrite(partners, fid);
				}
			}
			is.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public void shiftTweets() {
		try {
			BufferedReader is = new BufferedReader(new FileReader(IDLIST));
			String userId = null;
			while((userId = is.readLine()) != null) {
				userId = userId.trim();
				String ffile = EVENT_DIR + userId.substring(0,1) + "/" + userId + "_event";
				String tofile = THREAD_EMULATION_DATA + userId + "/" +userId + "_event";
				UserDataGenerator.copyfile(ffile, tofile);
				
				//followee
				String fe1file = FOLLOWEE_DIR + userId.substring(0,1) + "/" + userId + "_followee";
				String te2file = THREAD_EMULATION_DATA + userId + "/" +userId +  "_followee";
				UserDataGenerator.copyfile(fe1file, te2file);
				
				//follower
				String fr1file = FOLLOWER_DIR + userId.substring(0,1) + "/" + userId + "_follower";
				String tr2file = THREAD_EMULATION_DATA + userId + "/" +userId +  "_follower";
				UserDataGenerator.copyfile(fr1file, tr2file);
			}
			is.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		ThreadUserDataGenerator dg = new ThreadUserDataGenerator();
		//dg.printIdList2File();
		//dg.mkdirs();
		//System.out.println("-------mkdirs() done--------");
		
		//dg.shiftTweets();
		//System.out.println("-------shiftTweets() done--------");
		
		//dg.buildXMLProfiles();
		//System.out.println("--------buildProfiles() done-------");
		
		/*dg.buildFolloweeLinks();
		System.out.println("--------buildFolloweeLinks() done-------");
		
		dg.buildFollowerLinks();
		System.out.println("--------buildFollowerLinks() done-------");
		
		dg.buildPartners();
		System.out.println("--------buildPartners() done-------");
		*/
		dg.buildPortFile();
	}
}
