package infrastructure;

import java.util.Calendar;

import message.CuckooMsg;
import message.DirectUpdateStatusMsg;
import message.GossipFeedbackMsg;
import message.GossipUpdateStatusMsg;
import message.ReqNodeHandleMsg;

import org.mpisws.p2p.transport.exception.NodeIsFaultyException;

import application.Cuckoo;

import rice.p2p.commonapi.DeliveryNotification;
import rice.p2p.commonapi.MessageReceipt;
import toolbox.Mailbox;

//To know the send failure of directRoute
public class DirectDeliveryNotification implements DeliveryNotification{
	//private Exception exception;
	private Mailbox mailbox;
	private String userId;
	private Cuckoo cuckoo;
	private CuckooMsg msg;
	
	public DirectDeliveryNotification(Mailbox mb, String uid, Cuckoo cuc, CuckooMsg mg) {
		mailbox = mb;
		userId  = uid;
		cuckoo = cuc;
		msg = mg;
	}
	
	public void sendFailed(MessageReceipt arg0, Exception arg1) {
		//System.out.println("get into the sendFailed() function");
		cuckoo.deleteNodeHandle(userId);
		
		if(arg1 instanceof NodeIsFaultyException) {
			mailbox.add2mailbox(userId, msg);
		}
		
		int DoG = -1;
		String authorId = null;
		if(msg instanceof DirectUpdateStatusMsg) {
			DoG = 0;
			authorId = msg.getFromUserId();
		} else if(msg instanceof GossipUpdateStatusMsg) {
			DoG = 1;
			authorId = ((GossipUpdateStatusMsg) msg).getAuthorId();
		} else if(msg instanceof GossipFeedbackMsg) {
			DoG = 2;
			authorId = msg.getFromUserId();
		}
		
		//mailbox.printMailbox();
		//System.out.println("---------sff :-(---------------fromid[" + msg.getFromUserId() + "]  ->  toid[" + msg.getToUserId()+"]");
		cuckoo.reroute(Cuckoo.getIdFromString(userId), new ReqNodeHandleMsg(msg.getFrom(), msg.getTo(), msg.getFromUserId(), msg.getToUserId(), cuckoo.getNodeHandle(), Calendar.getInstance().getTimeInMillis(), cuckoo.getBloomFilter(), DoG, authorId), null);
		
		//no need to count a failure here!!!
		/*
		if(msg instanceof DirectUpdateStatusMsg) {
			cuckoo.decreaseFollowerHealth(msg.getToUserId());
		} else if(msg instanceof GossipUpdateStatusMsg) {
			if(msg.getFromUserId().compareTo(((GossipUpdateStatusMsg) msg).getAuthorId()) == 0) {
				cuckoo.decreaseFollowerHealth(msg.getToUserId());
			} else {
				cuckoo.decreasePartnerHealth(((GossipUpdateStatusMsg) msg).getAuthorId(), msg.getToUserId());
			}
		}
		*/
	}

	public void sent(MessageReceipt arg0) {
		//System.out.println(arg0);
		//System.out.println("##########scc B-)###########fromid[" + msg.getFromUserId() + "]  ->  toid[" + msg.getToUserId()+"]");
		
		if(msg instanceof GossipUpdateStatusMsg) {
			cuckoo.increaseGossipSent(((GossipUpdateStatusMsg) msg).getStatusId());
			
			if(msg.getFromUserId().compareTo(((GossipUpdateStatusMsg) msg).getAuthorId()) == 0) {
				cuckoo.increaseFollowerHealth(msg.getToUserId());
			} else {
				cuckoo.increasePartnerHealth(((GossipUpdateStatusMsg) msg).getAuthorId(), msg.getToUserId());
			}
		} else if(msg instanceof DirectUpdateStatusMsg) {
			/*
			if(cuckoo.isFollower(msg.getToUserId()) == false) {
				System.out.println("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
				System.out.println("msg.fromUserId = " + msg.getFromUserId());
				System.out.println("msg.toUserId = " + msg.getToUserId());
				System.out.println("msg.text = " + ((DirectUpdateStatusMsg) msg).getText());
			}
			*/
			cuckoo.increaseFollowerHealth(msg.getToUserId());
		}
	}
}
