package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;
import rice.p2p.util.BloomFilter;

public abstract class CuckooPiggybackMsg extends CuckooMsg {
	private static final long serialVersionUID = 201008081217L;
	
	protected BloomFilter bloomFilter;
	
	public CuckooPiggybackMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, BloomFilter bf) {
		super(from, to, fid, tid, nh, t);
		bloomFilter = bf;
	}
	
	public BloomFilter getBloomFilter() {
		return bloomFilter;
	}

	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
		bloomFilter.serialize(buf);
	}
	
	public CuckooPiggybackMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
		bloomFilter = new BloomFilter(buf);
	}
}
