package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;
import rice.p2p.util.BloomFilter;

public class RplNodeHandleErrMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201007191754L;
	public static final short TYPE = 9;
    private String originUserId;
    
    //ask for "direct" or "gossip" dissemination or "ack": 0 - direct; 1 - gossip; 2 - ack
	private int DoG; 
	private String authorId; //for gossip
    
    // Constructor.
    public RplNodeHandleErrMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, BloomFilter bf, String originId, int dog, String aid) {
    	super(from, to, fid, tid, nh, t, bf);
    	this.originUserId = originId;
    	this.DoG = dog;
    	authorId = aid;
    }
    
    public String getAuthorId() {
		return authorId;
	}

	public short getType() {
		return TYPE;
	}
	
	public int getDoG() {
		return DoG;
	}
	
	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
	    buf.writeUTF(originUserId);
	    buf.writeInt(DoG);
	    buf.writeUTF(authorId);
	}
	
	public RplNodeHandleErrMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    originUserId = buf.readUTF();
	    DoG = buf.readInt();
	    authorId = buf.readUTF();
	}
	
	public String getOriginId() {
		return originUserId;
	}
}
