package message;

import java.io.IOException;

import rice.p2p.commonapi.Endpoint;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandle;
import rice.p2p.commonapi.rawserialization.InputBuffer;
import rice.p2p.commonapi.rawserialization.OutputBuffer;
import rice.p2p.util.BloomFilter;

public class RplStatusErrMsg extends CuckooPiggybackMsg {
	private static final long serialVersionUID = 201004201510L;
	public static final short TYPE = 13;
    
    private String userId;
    
    private int achops;  //actually hops needed to get the status -- USED FOR MEASUREMENTS.
    private long actime; //actually time needed to get the status -- USED FOR MEASUREMENTS.
    private int rehops;
    private long retime;
    
    // Constructors.
    public RplStatusErrMsg(Id from, Id to, String fid, String tid, NodeHandle nh, long t, BloomFilter bf, String userId, int ach, long act, int reh, long ret) {
    	super(from, to, fid, tid, nh, t, bf);
    	this.userId = userId;
    	
    	this.achops = ach;
    	this.actime = act;
    	rehops = reh;
    	retime = ret;
    }
	
	public short getType() {
		return TYPE;
	}
	
	public void serialize(OutputBuffer buf) throws IOException {
		super.serialize(buf);
	    buf.writeUTF(userId);
	    
	    buf.writeInt(achops);
	    buf.writeLong(actime);
	    buf.writeInt(rehops);
	    buf.writeLong(retime);
	}

	public RplStatusErrMsg(InputBuffer buf, Endpoint endpoint) throws IOException {
		super(buf, endpoint);
	    userId = buf.readUTF();
	    
	    achops = buf.readInt();
	    actime = buf.readLong();
	    rehops = buf.readInt();
	    retime = buf.readLong();
	}
	
	public String getUserId() {
		return userId;
	}
	
	public int getAcHops() {
		return achops;
	}
	
	public long getAcTime() {
		return actime;
	}
	
	public int getReHops() {
		return rehops;
	}
	
	public long getReTime() {
		return retime;
	}
}
