package toolbox;

//import java.beans.XMLDecoder;
//import java.beans.XMLEncoder;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class ObjectSerialize {
	
	public static void object2file(Object obj, String filename) {
		try {
			//Create output file
			File fo = new File(filename);
			if(!fo.exists()) {
				//Create the dir first
				String path = filename.substring(0,filename.lastIndexOf('/'));
				File pFile = new File(path);
				pFile.mkdirs();        
			}
			
			FileOutputStream fos = new FileOutputStream(filename);
			ObjectOutputStream oos = new ObjectOutputStream(fos);
			oos.writeObject(obj);
			oos.close();
		} catch(FileNotFoundException fnfe) {
			System.out.println(fnfe.toString());
		} catch(IOException ioe) {
			System.out.println(ioe.toString());
		} 
			
	}
	
	public static Object file2object(String objSource) {
		File fin = new File(objSource);
		if(fin.exists() == false) {
			return null;
		}
		Object obj = null;
		while(true) {
			try {
				FileInputStream fis = new FileInputStream(fin);
				ObjectInputStream ois = new ObjectInputStream(fis);
				obj = ois.readObject();
			
				fis.close();
				ois.close();
			} catch(ClassNotFoundException cnfe) {
				System.out.println(cnfe.toString());
			} catch(FileNotFoundException fnfe) {
				System.out.println(fnfe.toString());
			} catch(IOException ioe) {
				//System.out.println("IOException in file2object");
				//System.out.println(ioe.toString());
				continue;
			}
			break;
		}
		return obj;
	} 
	
	/*
	public static void objectXmlEncoder(Object obj, String filename) {
		//throws FileNotFoundException,IOException,Exception
		try {  
			//Create output file
			File fo = new File(filename);
			if(!fo.exists()) {
				//Create the dir first
				String path = filename.substring(0,filename.lastIndexOf('/'));
				File pFile = new File(path);
				pFile.mkdirs();        
			}
			
			//Create output stream
			FileOutputStream fos = new FileOutputStream(fo);
			//Create the output instance (XML file)
			XMLEncoder encoder = new XMLEncoder(fos);  
			
			System.out.println("before write");
			
			encoder.writeObject(obj);
			encoder.flush();
			encoder.close();
		  	fos.close(); 
		  	  	
		} catch(FileNotFoundException fnfe) {
			System.out.println(fnfe.toString());
		} catch(IOException ioe) {
			System.out.println(ioe.toString());
		} 
	}
	
	public static Object objectXmlDecoder(String objSource) {
		File fin = new File(objSource);
		Object obj = null;
		try {
			FileInputStream fis = new FileInputStream(fin);
			XMLDecoder decoder = new XMLDecoder(fis);
			obj = decoder.readObject();
			
			fis.close();
			decoder.close();
			
		} catch(FileNotFoundException fnfe) {
			System.out.println(fnfe.toString());
		} catch(IOException ioe) {
			System.out.println(ioe.toString());
		} 
		return obj;
	}
	*/
	
	public static void main(String[] args) {
		String s = "abc";
		object2file(s, "./xml/test");
		String y = (String) file2object("./xml/test");
		System.out.println("y = " + y);
		
	}
}
