package toolbox;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

public class SizeCalculator {
	
	public int calcSize(java.io.Serializable o) {
		int ret = 0;
		
		DumbOutputStream buf = new DumbOutputStream();
		ObjectOutputStream os = null;
		
		try {
			os = new ObjectOutputStream(buf);
			os.writeObject(o);
			ret = buf.count;
		} catch(IOException ioe) {
			//No need handle this exception
			ioe.printStackTrace();
		} finally {
			try {
				os.close();
			} catch (Exception e) {}
		}
		return (ret*4);
	}
	
	////Do not use this
	////Only used for comparison with calcSize (the dump method)
	public void tranSizeOf(Object o) {
		try {
			ObjectOutputStream out=new ObjectOutputStream(new FileOutputStream("test.file"));
			out.writeObject(o);
			out.close();

			File f = new File("test.file"); 
			if (f.exists()) { 
				FileInputStream fis = null; 
				fis = new FileInputStream(f); 
				System.out.println("File has " + (double)((double)fis.available()/1000) + "KB"); 
			}
		} catch(FileNotFoundException fnfe) { 
			fnfe.printStackTrace(); 
		} catch(IOException ioe) { 
			ioe.printStackTrace(); 
		}
	}
	
	private class DumbOutputStream extends OutputStream {
		int count = 0;

	    public void write(int b) throws IOException {
	    	count++;  //only counting, do not cause real data transfer
	    }
	}
}
