package toolbox;

public class TrafficLog {
	private long rtime; //the time of recording the traffic log 
	
	private long traffic;
	private int contentLength;
	
	private long sendtime; //the time of sending the msg
	private long recvtime; //the time of receiving the msg
	private int hops;      //the network hops the message passing by
	
	private String fromId;
	private String toId;

	private short type;  //mesg type
	private String mark;  // From peer or server?
	private String inout; // Incoming or outgoing?
	private String redundancy;
	
	/*
	 * The name is a little bit confusing. 
	 *  -- Actually for GossipUpdateStatusMsg, it records the gossip time and gossip hops;
	 *  -- for ReqStatusMsg, it records the acTime and acHops
	 */
	private long gossiptime;
	private int  gossiphops;
	
	public TrafficLog(long ti, long tr, int cl, long st, long rt, int hp, short tp, String mk, String io, String fid, String tid, String re, long gt, int gh) {
		rtime    = ti;
		traffic = tr;
		contentLength = cl;
		
		sendtime = st;
		recvtime = rt;
		hops     = hp;
		
		type    = tp;
		mark    = mk;
		inout   = io;
		fromId  = fid;
		toId    = tid;
		redundancy = re;
		
		gossiptime = gt;
		gossiphops = gh;
	}
	
	public TrafficLog(String ti, String tr, int cl, long st, long rt, int hp, short tp, String mk, String io, String fid, String tid, String re, long gt, int gh) {
		rtime    = Long.valueOf(ti);
		traffic = Long.valueOf(tr);
		contentLength = cl;
		
		sendtime = st;
		recvtime = rt;
		hops     = hp;
		
		type    = tp;
		mark    = mk;
		inout   = io;
		fromId  = fid;
		toId    = tid;
		redundancy = re;
		
		gossiptime = gt;
		gossiphops = gh;
	}
	
	public String toString() {
		return rtime+"#"+
			traffic+"#"+
			contentLength+"#"+
			sendtime+"#"+
			recvtime+"#"+
			hops+"#"+
			type+"#"+
			mark+"#"+
			inout+"#"+
			fromId+"#"+
			toId+"#"+
			redundancy+"#"+
			gossiptime+"#"+
			gossiphops+"#";
	}
	
	/***************getters*******************/
	public long getTraffic() {
		return traffic;
	}
	
	public long getRTime() {
		return rtime;
	}
	
	public String getMark() {
		return mark;
	}
	
	public short getType() {
		return type;
	}
	
	public int getHops() {
		return hops;
	}
	
	public String getInOut() {
		return inout;
	}
	
	public String getFromId() {
		return fromId;
	}
	
	public String getToId() {
		return toId;
	}
	
	public String getRedundancy() {
		return redundancy;
	}
	
	public long getSendTime() {
		return sendtime;
	}
	
	public long getRecvTime() {
		return recvtime;
	}
	
	public int getContentLength() {
		return contentLength;
	}
	
	public long getGossipTime() {
		return gossiptime;
	}
	
	public int getGossipHops() {
		return gossiphops;
	}
}
